(function() {
	if (window.WebViewJavascriptBridge) { return }
	var _addMessageIframe
	var _setResultIframe;
	var sendMessageQueue = []
	var _session_data = {}
	var _callback_map = {}
	var _event_hook_map = {}
	var receiveMessageQueue = []
	var _callback_count = 1000
	var _CUSTOM_PROTOCOL_SCHEME = 'teamtalk'
	var _QUEUE_HAS_MESSAGE = 'dispatch/'
	var _SCENE_FETCH_QUEUE = '__SCENE_FETCH_QUEUE__'
	var _SCENE_HANDLE_MESSAGE_FROM_TT = "__HANDLE_MESSAGE_FROM_TT__"
	var _MESSAGE_TYPE = '__msg_type'
	var _CALLBACK_ID = '__callback_id'
	var _EVENT_ID = '__event_id'
	var responseCallbacks = {}
	var uniqueId = 1

	function _createQueueReadyIframe(doc) {
		_setResultIframe = doc.createElement('iframe');
		_setResultIframe.id = '__TTJSBridgeIframe_SetResult';
		_setResultIframe.style.display = 'none';
		doc.documentElement.appendChild(_setResultIframe);

		_addMessageIframe = doc.createElement('iframe')
		_addMessageIframe.id = '__TTJSBridgeIframe_Message';
		_addMessageIframe.style.display = 'none'
		doc.documentElement.appendChild(_addMessageIframe)
	}

	function init(messageHandler) {
		if (WebViewJavascriptBridge._messageHandler) { throw new Error('WebViewJavascriptBridge.init called twice') }
		WebViewJavascriptBridge._messageHandler = messageHandler
		var receivedMessages = receiveMessageQueue
		receiveMessageQueue = null
		for (var i=0; i<receivedMessages.length; i++) {
			_dispatchMessageFromNative(receivedMessages[i])
		}
	}

    var base64encodechars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

    function base64encode(str) {
                if (str === undefined) {
                    return str;
                }

                var out, i, len;
                var c1, c2, c3;
                len = str.length;
                i = 0;
                out = "";
                while (i < len) {
                    c1 = str.charCodeAt(i++) & 0xff;
                    if (i == len) {
                        out += base64encodechars.charAt(c1 >> 2);
                        out += base64encodechars.charAt((c1 & 0x3) << 4);
                        out += "==";
                        break;
                    }
                    c2 = str.charCodeAt(i++);
                    if (i == len) {
                        out += base64encodechars.charAt(c1 >> 2);
                        out += base64encodechars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xf0) >> 4));
                        out += base64encodechars.charAt((c2 & 0xf) << 2);
                        out += "=";
                        break;
                    }
                    c3 = str.charCodeAt(i++);
                    out += base64encodechars.charAt(c1 >> 2);
                    out += base64encodechars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xf0) >> 4));
                    out += base64encodechars.charAt(((c2 & 0xf) << 2) | ((c3 & 0xc0) >> 6));
                    out += base64encodechars.charAt(c3 & 0x3f);
                }
                return out;
            }

	function _setDefaultEventHandlers() {
		// set font
		_registerEventHandler('menu:setfont', function (argv) {
			//alert('setfont')
			if (typeof changefont === 'function') {
				var num = parseInt(argv.fontSize);
				_log('set font size with changefont: %s', argv.fontSize);
				changefont(num);
				return;
			}

			// fallback
			var s;
			switch (argv.fontSize) {
				case '1':
					s = '80%';
					break;
				case '2':
					s = '100%';
					break;
				case '3':
					s = '120%';
					break;
				case '4':
					s = '140%';
					break;
				default :
					return;
			}
			//_log('set font size with webkitTextSizeAdjust: ' + s);
			// document.getElementsByTagName('body')[0].style.webkitTextSizeAdjust = s;
			// android机器上调用该方法不生效，改为回调到java层，用webview的api实现setFontSize
			_callNative('setFontSizeCallback', {"fontSize": s});
		});

		_registerEventHandler('sys:init',function(ses){
            // 避免由于Java层多次发起init请求，造成网页端多次收到WeixinJSBridgeReady事件
            if (window.WebViewJavascriptBridge.hasInit) {
                _log('hasInit, no need to init again');
                return;
            }

            window.WebViewJavascriptBridge.hasInit = true;

            _session_data = ses;

            // bridge ready
            var readyEvent = doc.createEvent('Events');
            readyEvent.initEvent('WebViewJavascriptBridgeReady');
            doc.dispatchEvent(readyEvent);
        });

	}

	function _registerEventHandler(event,callback){
		if (!event || typeof event !== 'string') {
			return;
		};

		if (typeof callback !== 'function') {
			return;
		};

		_event_hook_map[event] = callback;
	}

	function _callTest(msgObj) {
	    var message = JSON.parse(msgObj)
	    sendMessageQueue.push(message)
        _setMessageResult(_CUSTOM_PROTOCOL_SCHEME, _QUEUE_HAS_MESSAGE);
	}

	function _call(msgObj) {
	    _addMessageIframe.src = msgObj
	}

	function _callNative(func,params,callback) {
		if (!func || typeof func !== 'string') {
			return;
		};
		if (typeof params !== 'object') {
			params = {};
		};
		var msgObj = {'func':func,'__params':params};
		msgObj[_MESSAGE_TYPE] = 'call';
		console.log("callNative: ");
		//alert('call ' + func)
		if (typeof callback === 'function') {
			var callbackID = (_callback_count++).toString();
			_callback_map[callbackID] = callback;
			msgObj[_CALLBACK_ID] = callbackID;
		};
		sendMessageQueue.push(msgObj)
		_setMessageResult(_CUSTOM_PROTOCOL_SCHEME, _QUEUE_HAS_MESSAGE);
	}

	function _log(fmt, callback) {
		var argv = [];
		for (var i = 0; i < arguments.length; i++) {
			argv.push(arguments[i]);
		};
		var fm = argv.shift();
		var msg;
		try {
			msg = vsprintf(fm,argv);
		}catch(e) {
			msg = fmt;
		}
		//var test = function() {alert('test')};
		_callNative('log',{'tag': 'hjinw','msg':msg}, callback);
	}

	function _fetchQueue() {
		var messageQueueString = JSON.stringify(sendMessageQueue)
		//alert(messageQueueString)
		sendMessageQueue = []
		_setResultValue(_SCENE_FETCH_QUEUE, messageQueueString)
		return messageQueueString
	}

	function _setMessageResult(scene, result) {
		_addMessageIframe.src = scene + '://' + result
	}

	function _setResultValue(scene, result) {
    		if (result === undefined) {
    			result = 'dummy';
    		}
		_setResultIframe.src = _CUSTOM_PROTOCOL_SCHEME + '://private/result/' + scene + '&' + base64encode(result); //base64encode(UTF8.encode(result));
    }

	function _dispatchMessageFromNative(messageJSON) {
		setTimeout(function _timeoutDispatchMessageFromNative() {
			var msgWrap = JSON.parse(messageJSON)
			switch (msgWrap[_MESSAGE_TYPE]) {
				case 'callback':
				{
					if (typeof msgWrap[_CALLBACK_ID] === 'string' && typeof _callback_map[msgWrap[_CALLBACK_ID]] === 'function') {
						var ret = _callback_map[msgWrap[_CALLBACK_ID]](msgWrap['__params']);
						delete _callback_map[msgWrap[_CALLBACK_ID]]; // can only call once
						_log("callback: " + msgWrap[_CALLBACK_ID])
						_setResultValue(_SCENE_HANDLE_MESSAGE_FROM_TT, JSON.stringify(ret));
						return JSON.stringify(ret);
					}
					
					_setResultValue(_SCENE_HANDLE_MESSAGE_FROM_TT, JSON.stringify({'__err_code': 'cb404'}));
					return JSON.stringify({'__err_code': 'cb404'});
				}
					break;
				case 'event':
				{
					if (typeof msgWrap[_EVENT_ID] === 'string' && typeof _event_hook_map[msgWrap[_EVENT_ID]] === 'function') {
						var ret = _event_hook_map[msgWrap[_EVENT_ID]](msgWrap['__params']);
						
						if (typeof msgWrap['__event_call_back'] == 'string') {
							var callback = []
							callback.push({'__callback_id':msgWrap['__event_call_back']})
							_setResultValue(_SCENE_HANDLE_MESSAGE_FROM_TT, JSON.stringify(callback));
						} else {
							_setResultValue(_SCENE_HANDLE_MESSAGE_FROM_TT, JSON.stringify(ret));
						}
						return JSON.stringify(ret);
					}
					
					_setResultValue(_SCENE_HANDLE_MESSAGE_FROM_TT, JSON.stringify({'__err_code': 'ev404'}));
					return JSON.stringify({'__err_code': 'ev404'});
				}
					break;
			}
		})
	}
	
	function _handleMessageFromNative(messageJSON) {
		if (receiveMessageQueue) {
			receiveMessageQueue.push(messageJSON)
		} else {
			_dispatchMessageFromNative(messageJSON)
		}
	}

	window.WebViewJavascriptBridge = {
		init: init,
		callNative: _callNative,
		call: _call,
		callTest: _callTest,
		log:_log,
		fetchQueue: _fetchQueue,
		dispatchMsgToJs: _handleMessageFromNative,
		hasInit: false
	}

	var doc = document
	_createQueueReadyIframe(doc)
	var readyEvent = doc.createEvent('Events')
	readyEvent.initEvent('WebViewJavascriptBridgeReady')
	readyEvent.bridge = WebViewJavascriptBridge
	doc.dispatchEvent(readyEvent)
	_setDefaultEventHandlers()
})();
